;////////////////////////////////////////////////////////////////////////////;
;/ asm.s                                                                    /;
;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;
;/ includes                                                                 /;
;////////////////////////////////////////////////////////////////////////////;
	.include "\dev\gb\lib\global.s"

;////////////////////////////////////////////////////////////////////////////;
;/ globals                                                                  /;
;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;
	.area	_HEADER (ABS)
;////////////////////////////////////////////////////////////////////////////;
	.org	0x40		;VBL irq
	reti;jp		.vbl_irq

	.org	0x48		;LCD irq
	reti;jp		.lcd_irq

;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE
;////////////////////////////////////////////////////////////////////////////;
;mode		clks*		clks* (2x)	interrupt setting
;----------	-----------	-----------	------------------------
;0 hbl		204			408			STAT=0x08;
;2 oam		80			160			STAT=0x44; (coincidence)
;3 oam+disp	172			344			STAT=0x44; (coincidence)
;0+2		284			568
;2+3		252			504
;1 vbl		4560		9120

;////////////////////////////////////////////////////////////////////////////;
;/ .vbl_irq                                                                 /;
;////////////////////////////////////////////////////////////////////////////;
.vbl_irq:
	push	af
	
	xor		a, a
	ldh		(.LYC), a
	
	pop		af
	reti

;////////////////////////////////////////////////////////////////////////////;
;/ .lcd_irq                                                                 /;
;////////////////////////////////////////////////////////////////////////////;
.lcd_irq:
	push	af
	push	bc

	;ld		a, #0xC1
	;ldh		(.LCDC), a
	;ld		a, #160
	;ldh		(.SCX), a
	

;1$:
	;ldh		a, (.STAT)
	;and		a, #0x03
	;cp		a, #0x03
	;jr		nz, 1$

	ldh		a, (.LY)
	inc		a
	ldh		(.LYC), a


	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	ld		c, #0x42
	xor		a, a
	
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	ldh		(c), a
	inc		a
	nop
	
	
	;ld		a, #0xC9
	;ldh		(.LCDC), a
	;ld		a, #-64
	;ldh		(.SCX), a


	
	pop		bc
	pop		af
	reti

;////////////////////////////////////////////////////////////////////////////;
;/ _Do                                                                      /;
;////////////////////////////////////////////////////////////////////////////;
_Do::
	push bc
	
	ld		hl, #0x0000 + .BCPS
;	ld		hl, #0xFF00 + .BCPS

.loop1:

;wait_vbl
	ldh	a, (.LY)
	cp	a, #144
	jr	nz, . - 4



	ld	b, #144
.loop2:



	;wait for mode 0
	halt

	;upload 4 palettes
	ld		a, #0x80
	ld		(hl+), a
	ld	(hl), #0x1F
	ld	(hl), #0x00
	ld	(hl), #0xBC
	ld	(hl), #0x77
	ld	(hl), #0xBC
	ld	(hl), #0x77
	ld	(hl), #0xBC
	ld	(hl), #0x77
	ld	(hl), #0x1F
	ld	(hl), #0x00
	ld	(hl), #0xBC
	ld	(hl), #0x77
	ld	(hl), #0xBC
	ld	(hl), #0x77
	ld	(hl), #0xBC
	ld	(hl), #0x77
	ld	(hl), #0x1F
	ld	(hl), #0x00
	ld	(hl), #0xBC
	ld	(hl), #0x77
	ld	(hl), #0xBC
	ld	(hl), #0x77
	ld	(hl), #0xBC
	ld	(hl), #0x77
	ld	(hl), #0x1F
	ld	(hl), #0x00
	ld	(hl), #0xBC
	ld	(hl), #0x77
	ld	(hl), #0xBC
	ld	(hl), #0x77
	ld	(hl), #0xBC
	ld	(hl), #0x77
	dec		l


	ld		a, #0x80
	ldh		(.LCDC), a
	ld		a, #160
	ldh		(.SCX), a


	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	;we need to scroll and switch map very fast
	push	hl

	ld		hl, #0xFF00+.SCX
	ld		c, #.LCDC
	ld		a, #0x88
	
	ld		(hl), #-64
	ldh		(c), a
	
	pop		hl





	dec		b
	jp		nz, .loop2

	jp		.loop1



	pop	bc
	ret
